package chat.chatserver.chatviews;

import limax.provider.TemporaryView.MemberShip.AbortReason;
import limax.provider.ViewContext;
import limax.provider.ViewStub;
import limax.util.Resource;
import chat.chatserver.Main;
import chat.chatviews.ChatMessage;
import chat.chatviews.monitor.RoomInfo;

public final class ChatRoom extends chat.chatserver.chatviews._ChatRoom {

	private ChatRoom(ViewContext context, ViewStub stub, Resource resource) {
		super(context, stub, resource);
		ChatRoom.this.setLastmessage(new ChatMessage("", -1));
	}

	@Override
	protected void onClose() {
	}

	@Override
	protected void onAttachAbort(long sessionid, AbortReason reason) {
	}

	@Override
	protected void onDetachAbort(long sessionid, AbortReason reason) {
	}

	@Override
	protected void onAttached(long sessionid) {
		RoomInfo.increment_memberCount_mapkey(roomid, 1L);
	}

	@Override
	protected void onDetached(long sessionid, byte reason) {
		RoomInfo.increment_memberCount_mapkey(roomid, -1L);
		UserInfo.getInstance(sessionid).checkUpdateHallInfos();
	}

	private long roomid;

	void setRoomId(long id) {
		roomid = id;
	}

	@Override
	protected void onMessage(String message, long sessionid) {
		int index = message.indexOf('=');
		if (-1 == index)
			return;
		final String cmd = message.substring(0, index).trim();
		final String params = message.substring(index + 1);
		switch (cmd) {
		case "message": {
			index = params.indexOf(',');
			if (-1 == index)
				return;
			final long toid = Long.parseLong(params.substring(0, index).trim());
			final String msg = params.substring(index + 1).trim();
			if (Main.checkAndRunCommand(sessionid, msg))
				return;
			if (-1L == toid) {
				ChatRoom.this.setLastmessage(new ChatMessage(msg, sessionid));
				RoomInfo.increment_publicMessages_mapkey(roomid);
			} else {
				UserInfo.getInstance(toid).setRecvedmessage(
						new ChatMessage(msg, sessionid));
				UserInfo.getInstance(sessionid).setSendedmessage(
						new ChatMessage(msg, toid));
				RoomInfo.increment_privateMessages_mapkey(roomid);
			}
			return;
		}
		case "leave": {
			getMemberShip().remove(sessionid, (byte) 1);
			return;
		}
		}
	}

}
