package limax.auany.auanyviews;

import limax.auany.__ProtocolProcessManager;
import limax.defines.ErrorCodes;
import limax.defines.ErrorSource;
import limax.provider.TemporaryView.MemberShip.AbortReason;
import limax.provider.ViewContext;
import limax.provider.ViewStub;
import limax.util.Resource;
import limax.util.Trace;

public final class ExperienceUpgrade extends
		limax.auany.auanyviews._ExperienceUpgrade {

	private ExperienceUpgrade(ViewContext context, ViewStub stub,
			Resource resource) {
		super(context, stub, resource);
	}

	@Override
	protected void onClose() {
		if (Trace.isInfoEnabled())
			Trace.info("ExperienceUpgrade onClose");
	}

	@Override
	protected void onAttachAbort(long sessionid, AbortReason reason) {
		if (Trace.isInfoEnabled())
			Trace.info("ExperienceUpgrade onAttachAbort sessionid = "
					+ sessionid + " reason = " + reason);
	}

	@Override
	protected void onDetachAbort(long sessionid, AbortReason reason) {
		if (Trace.isInfoEnabled())
			Trace.info("ExperienceUpgrade onDetachAbort sessionid = "
					+ sessionid + " reason = " + reason);
	}

	@Override
	protected void onAttached(long sessionid) {
		if (Trace.isInfoEnabled())
			Trace.info("ExperienceUpgrade onAttached sessionid = " + sessionid);
	}

	@Override
	protected void onDetached(long sessionid, byte reason) {
		if (Trace.isInfoEnabled())
			Trace.info("ExperienceUpgrade onDetached sessionid = " + sessionid
					+ " reason = " + reason);
		if (reason >= 0) {
			// Application reason
		} else {
			// Connection abort reason
		}
	}

	@Override
	protected void onControl(_ExperienceUpgrade.Upgrade param, long sessionid) {
		__ProtocolProcessManager.onViewControl(this, sessionid, param.username,
				param.token, param.platflag);
	}

	@Override
	protected void onMessage(String message, long sessionid) {
		final String cmd;
		final int index = message.indexOf('=');
		if (-1 == index)
			cmd = message;
		else
			cmd = message.substring(0, index);
		final String[] args = message.substring(index + 1).split(",");
		switch (cmd.toLowerCase()) {
		case "upgrade":
			if (args.length == 3)
				__ProtocolProcessManager.onViewControl(this, sessionid,
						args[0], args[1], args[2]);
			else {
				setErrorcodes(new limax.auanyviews.ErrorCodes(
						ErrorSource.LIMAX,
						ErrorCodes.AUANY_EXPERIENCE_UPGRADE_BAD_ARGS));
				destroyInstance();
			}
			break;
		}
	}

	static void start(long sessionid, long sn) {
		ExperienceUpgrade view = createInstance();
		view.getMemberShip().add(sessionid);
		view.setSn(sn);
	}

}
