package limax.codec;

public abstract class Codec {
	private static Codec _null = new Codec() {
		public void update(byte c) {
		}

		public void update(byte[] data, int off, int len) {
		}

		public void flush() {
		}
	};

	public abstract void update(byte c) throws CodecException;

	public abstract void update(byte[] data, int off, int len)
			throws CodecException;

	public abstract void flush() throws CodecException;

	public static Codec Null() {
		return _null;
	}
}
