package limax.edb;

import java.util.concurrent.locks.ReentrantLock;

final class HashLock {

	final private ReentrantLock[] locks;

	HashLock(int size) {
		locks = new ReentrantLock[size];
		for (int i = 0; i < size; i++)
			locks[i] = new ReentrantLock();
	}

	void lock(long n) {
		int key = (int) ((n >> 32) ^ n) & 0x7FFFFFFF;
		locks[key % locks.length].lock();
	}

	boolean tryLock(long n) {
		int key = (int) ((n >> 32) ^ n) & 0x7FFFFFFF;
		return locks[key % locks.length].tryLock();
	}

	void unlock(long n) {
		int key = (int) ((n >> 32) ^ n) & 0x7FFFFFFF;
		locks[key % locks.length].unlock();
	}

}
